/***************************************************************************
                          idux.h  -  Includes, plus declarations.
                             -------------------
    begin                : Mon Nov 3 2003
    copyright            : (C) 2003 by Miguel Morales
    email                : mrx@netlane.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <string>
#include <iostream>
#include <fstream>
#include <getopt.h>
using std::ifstream;
using std::ofstream;
using std::ios_base;
using std::ios;
using std::string;
using std::cout;
using std::endl;
using std::cin;
using std::cerr;
using std::auto_ptr ;
bool file_exists (const char *);
void fatal_exit (const char *, ...);
void parse_file (const char *);

#undef ERROR
enum				//Section names...
{
  ERROR,
  SETUP,
  FILES
};

class FileList //This link list will hold dirs and filenames
{
public:
FileList *next;
string name;
string path;
string flags;
};

class
      options
  {
  public:
    /*[Setup] fields*/
    string    AppName;
    string    AppDesc;
    string    AppCopyright;
    string    AppVersion;
    string    AppLicense;
    string    LicenseString;		//This will hold the contents of the AppLicense file
    string    DefaultPath;

    /*[Files] fields*/
    int    nfiles,    ndirs;
    FileList *files;
    /*custom directories*/
    string    directories[1024];
    int    dircounter;
    /*This is the constructor that sets the default values*/
    options ();
    /*Destructor*/
    ~options();
    /*for debugging*/
    void    print_options ();
  };

extern struct options opt;

